'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.createOpenItemHandler = createOpenItemHandler;

var _utilities = require('./utilities');

function createOpenItemHandler(fileStructure) {
    return function openItem(request, response) {
        var itemUrl = request.params[0];
        var itemPath = (0, _utilities.getItemPath)(fileStructure, itemUrl);

        var file = fileStructure.allFilesByPath[itemPath];
        var directory = fileStructure.allDirectoriesByPath[itemPath];

        var item = file || directory;

        if (!item) {
            return (0, _utilities.respondItemNotFound)(itemPath, response);
        }

        response.send(item.serialise());
    };
} // Dependencies: