'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.createRefactorItemHandler = createRefactorItemHandler;

var _utilities = require('./utilities');

var _tractorErrorHandler = require('tractor-error-handler');

// Dependencies:
function createRefactorItemHandler(fileStructure) {
    return function refactorItem(request, response) {
        var update = request.body.update;

        var itemUrl = request.params[0];
        var itemPath = (0, _utilities.getItemPath)(fileStructure, itemUrl);

        var toRefactor = fileStructure.allFilesByPath[itemPath];

        if (!toRefactor) {
            return (0, _utilities.respondItemNotFound)(itemPath, response);
        }

        return toRefactor.refactor(update).then(function () {
            return (0, _utilities.respondOkay)(response);
        }).catch(_tractorErrorHandler.TractorError.isTractorError, function (error) {
            return (0, _tractorErrorHandler.handleError)(response, error);
        }).catch(function () {
            return (0, _tractorErrorHandler.handleError)(response, new _tractorErrorHandler.TractorError('Could not refactor "' + itemPath + '"'));
        });
    };
}

// Errors: