'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.serveFileStructure = serveFileStructure;

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _deleteItem = require('./actions/delete-item');

var _moveItem = require('./actions/move-item');

var _openItem = require('./actions/open-item');

var _refactorItem = require('./actions/refactor-item');

var _saveItem = require('./actions/save-item');

var _watchFileStructure = require('./actions/watch-file-structure');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Actions:
function serveFileStructure(application, sockets) {
    return function (fileStructure, prefix) {
        application.use('/' + prefix + '/fs/static/', _express2.default.static(fileStructure.path));

        application.delete('/' + prefix + '/fs*', (0, _deleteItem.createDeleteItemHandler)(fileStructure));
        application.post('/' + prefix + '/fs/move*', (0, _moveItem.createMoveItemHandler)(fileStructure));
        application.get('/' + prefix + '/fs*', (0, _openItem.createOpenItemHandler)(fileStructure));
        application.post('/' + prefix + '/fs/refactor*', (0, _refactorItem.createRefactorItemHandler)(fileStructure));
        application.put('/' + prefix + '/fs*', (0, _saveItem.createSaveItemHandler)(fileStructure));

        (0, _watchFileStructure.watchFileStructure)(fileStructure, sockets.of('/' + prefix + '/watch-file-structure'));
    };
} // Dependencies:

serveFileStructure['@Inject'] = ['application', 'sockets'];