"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ReferenceManager = exports.ReferenceManager = function () {
    function ReferenceManager(fileStructure) {
        _classCallCheck(this, ReferenceManager);

        this.fileStructure = fileStructure;
        this.references = {};
        this.referencedBy = {};
        this.fileStructures = [];
    }

    _createClass(ReferenceManager, [{
        key: "addFileStructure",
        value: function addFileStructure(fileStructure) {
            if (!this.fileStructures.includes(fileStructure)) {
                this.fileStructures.push(fileStructure);
                fileStructure.referenceManager.addFileStructure(this.fileStructure);
            }
        }
    }, {
        key: "getFileStructures",
        value: function getFileStructures() {
            return [this.fileStructure].concat(this.fileStructures);
        }
    }, {
        key: "addReference",
        value: function addReference(from, to) {
            this.references[from.path] = this.references[from.path] || [];
            var references = this.references[from.path];
            if (!references.includes(to) && !hasFileByPath(references, to.path)) {
                references.push(to);
            }

            this.referencedBy[to.path] = this.referencedBy[to.path] || [];
            var referencedBy = this.referencedBy[to.path];
            if (!referencedBy.includes(from) && !hasFileByPath(referencedBy, from.path)) {
                referencedBy.push(from);
            }
        }
    }, {
        key: "getReference",
        value: function getReference(path) {
            var fileStructure = this.getFileStructures().find(function (fileStructure) {
                return fileStructure.allFilesByPath[path];
            });
            return fileStructure ? fileStructure.allFilesByPath[path] : null;
        }
    }, {
        key: "getReferences",
        value: function getReferences(path) {
            var references = [];
            this.getFileStructures().forEach(function (fileStructure) {
                references = references.concat(fileStructure.referenceManager.references[path] || []);
            });
            return references;
        }
    }, {
        key: "getReferencedBy",
        value: function getReferencedBy(path) {
            var referencedBy = [];
            this.getFileStructures().forEach(function (fileStructure) {
                referencedBy = referencedBy.concat(fileStructure.referenceManager.referencedBy[path] || []);
            });
            return referencedBy;
        }
    }, {
        key: "clearReferences",
        value: function clearReferences(path) {
            this.getFileStructures().forEach(function (fileStructure) {
                var _fileStructure$refere = fileStructure.referenceManager,
                    references = _fileStructure$refere.references,
                    referencedBy = _fileStructure$refere.referencedBy;

                references[path] = [];
                removeFileByPath(referencedBy, path);
            });
        }
    }, {
        key: "clearReferencedBy",
        value: function clearReferencedBy(path) {
            this.getFileStructures().forEach(function (fileStructure) {
                var _fileStructure$refere2 = fileStructure.referenceManager,
                    references = _fileStructure$refere2.references,
                    referencedBy = _fileStructure$refere2.referencedBy;

                referencedBy[path] = [];
                removeFileByPath(references, path);
            });
        }
    }]);

    return ReferenceManager;
}();

function hasFileByPath(references, path) {
    return !!references.find(function (file) {
        return file.path === path;
    });
}

function removeFileByPath(references, path) {
    Object.keys(references).forEach(function (referencePath) {
        var index = references[referencePath].findIndex(function (reference) {
            return reference.path === path;
        });
        if (index >= 0) {
            references[referencePath].splice(index, 1);
        }
    });
}